"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchQueryBuilder = void 0;
class SearchQueryBuilder {
    constructor(schema) {
        this.schema = schema;
        this.query = {};
    }
    bool(boolType, queries) {
        if (!this.query.hasOwnProperty('bool')) {
            this.query.bool = {};
        }
        this.query.bool[boolType] = queries;
        return this;
    }
    phrase(field, terms) {
        if (!this.query.hasOwnProperty('phrase')) {
            this.query.phrase = {};
        }
        this.query.phrase[field] = { terms };
        return this;
    }
    setLimit(limit) {
        this.limit = limit;
        return this;
    }
    term(field, value) {
        return { term: { [field]: value } };
    }
    getQuery() {
        return { query: this.query, limit: this.limit };
    }
}
exports.SearchQueryBuilder = SearchQueryBuilder;
//# sourceMappingURL=searchquerybuilder.js.map