// @ts-ignore
import Server from '@arsonar/server/test/lib/create.js';
import { Workspace } from '../../index.js';
async function createOne(opts = {}) {
    const { server, endpoint, cleanup: cleanupServer } = await Server.createOne(opts);
    const clientOpts = opts.clientOpts || {};
    const client = new Workspace({ endpoint, ...clientOpts });
    return { server, cleanup, endpoint, client };
    async function cleanup() {
        await client.close();
        await cleanupServer();
    }
}
async function createMany(n, opts = {}) {
    const instances = await Server.createMany(n, opts);
    instances.clients = instances.endpoints.map((endpoint) => {
        return new Workspace({ endpoint });
    });
    const cleanup = instances.cleanup;
    instances.cleanup = async function () {
        await Promise.all(instances.clients.map((client) => client.close()));
        await cleanup();
    };
    return instances;
}
export { createOne };
export { createMany };
export default {
    createOne,
    createMany
};
//# sourceMappingURL=create.js.map